<?php
//TODO закрыть от общего доступа
require_once('api/Okay.php');
$okay = new Okay();
?>
<title>update_features.php v1.2</title>
<form method="post" style="width: 800px; margin: 0 auto;">

    <div class="warning_text">
        <p>Пользуясь данным интерфейсом, вы осознаете, что будет обновляться база, и у вас есть резервная копия базы данных.<br>
            Настоятельно рекомендуется не запускать данный скрипт на production-сервере.<br>
            Разработчики данного скрипта не несут ответственность за сохранность данных после обработки их данным скриптом.</p>
    </div>

    <?php
        if (!isset($_POST['check_unique_options']) && !isset($_POST['new_values'])) {
    ?>
    <input name="check_unique_options" value="Проверить унакальные значения свойств" type="submit"/>
    <?php
        } else {
            if (($new_values = $okay->request->post('new_values')) && ($okay->request->post('i_agree', 'boolean') === true)) {
                $generate_translit = $okay->request->post('generate_translit');
                foreach ($new_values as $lang_id=>$features) {
                    foreach ($features as $feature_id=>$nv) {
                        foreach ($nv as $translit=>$value) {
                            // Если отметили перегенерить транслит
                            if (isset($generate_translit[$lang_id][$feature_id][$translit])) {
                                $query = $okay->db->placehold("SELECT distinct( BINARY `o`.`value`) as `value`, `o`.`feature_id`, `o`.`lang_id`
                                      FROM `__options` AS `o`
                                      LEFT JOIN `__features` AS `f` ON `o`.`feature_id`=`f`.`id`
                                      WHERE `o`.`feature_id`=? AND `o`.`translit`=? AND `o`.`lang_id`=?
                                      ", (int)$feature_id, $translit, (int)$lang_id);

                                $okay->db->query($query);

                                if ($results = $okay->db->results()) {
                                    foreach ($results as $result) {
                                        $translit = translit_alpha($result->value);
                                        $okay->db->query("UPDATE `__options` SET `translit`=? WHERE `lang_id`=? AND `value`=? AND `feature_id`=?", (string)$translit, (int)$result->lang_id, (string)$result->value, (int)$result->feature_id);
                                    }
                                }
                            // Иначе приведем значения к одному виду
                            } else {
                                $value = trim($value);
                                if (!empty($value)) {
                                    $okay->db->query("UPDATE `__options` SET `value`=? WHERE `lang_id`=? AND `translit`=? AND `feature_id`=?", (string)$value, (int)$lang_id, (string)$translit, (int)$feature_id);
                                }
                            }

                        }
                    }
                }
            }

            $langs = array();
            $okay->db->query("SELECT `id`, `label` FROM `__languages`");
            foreach ($okay->db->results() as $res) {
                $langs[$res->id] = $res->label;
            }
            if (count($langs) <= 1) {
                $langs = array();
            }

            $query = $okay->db->placehold("SELECT MAX(`f`.`name`) as `name`, MAX(`o`.`feature_id`) as `feature_id`, MAX(`o`.`lang_id`) as `lang_id`, COUNT(distinct( BINARY `o`.`value`)) as `count`, MAX(`o`.`translit`) as `translit`, MAX(`o`.`value`) as `value`
                  FROM `__options` AS `o`
                  LEFT JOIN `__features` AS `f` ON `o`.`feature_id`=`f`.`id`
                  GROUP BY  `o`.`feature_id`, `o`.`translit`, `o`.`lang_id`
                  HAVING `count` > 1");

            $okay->db->query($query);
            if ($results = $okay->db->results()) {
                ?>
                <div class="warning_text">
                    У вас найдены разные варианты значений свойств с одинаковым транслитом. Нужно их привести к единому виду.
                    Можно это сделать самостоятельно через админпанель сайта или же через данный интерфейс.
                    Нужно в выпадающих списках выбирать вариант значения, который нужно оставить.
                    Во всех товарах, где был другой вариант этого значения, он будет заменен на выбранный.
                    <p>Даже если вы видите варианты: <b>"ЖК телевизор"</b> и <b>"ЖК телевизoр"</b> знайте, они разные :)</p>
                    Данный интерфейс предполагает, что есть ошибочные дубликаты значений, которые различаются регистром букв, пробелами, дефисами...
                    Если же система показывает как дубликаты, значения которые на самом деле разные, напр.: "< 5,2 КГ", "5.2 КГ", "52 КГ" (у них всех транислит одинаков – "52kg"),
                    тогда нужно сразу выполнить поиск и замену спецсимволов в значениях. Для этого нужно отметить галочкой нужную строку и значения не будут обновлены, а перегенерируется транслит.<br>
                    Внимание: могут быть комбинированные ситуации, такие ситуации лучше обработать отдельно руками перед обработкой данным интерфейсом.<br>
                    <b>Если будут генериться новые транслиты значений, проиндексированные страницы фильтров будут отдавать 404 т.к. таких страниц больше не будет.</b>


                    <?php
                    $fields_count = count($results);
                    if ($fields_count > ini_get('max_input_vars')) {
                        print "<p>WARNING: у вас на сервере директива \"max_input_vars\" установлена в ".ini_get('max_input_vars').", а полей для обновления >{$fields_count} шт.
                            Нужно либо изменить данную директиву на большее значение, либо обновить значения за несколько запросов.</p>";
                    }
                    ?>

                </div>

                <div style="margin: 20px 0;color: red;">
                    <input id="i_agree" class="no_check" type="checkbox" name="i_agree" value="1" />
                    <label for="i_agree">Я создал резервную копию базы данных сайта, и понимаю что сейчас текущая база данных будет обновляться</label>
                </div>

                <script>
                    function checkAll(obj, selector) {
                        var items = obj.form.getElementsByTagName("input"),
                            len, i;
                        for (i = 0, len = items.length; i < len; i += 1) {
                            if (items.item(i).type && items.item(i).type === "checkbox") {
                                if (!items.item(i).classList.contains('no_check') && (selector == '' || items.item(i).classList.contains(selector))) {
                                    if (obj.checked) {
                                        items.item(i).checked = true;
                                    } else {
                                        items.item(i).checked = false;
                                    }
                                }
                            }
                        }
                    }
                </script>

                <table style="width: 100%;">

                    <tr>
                        <td style="width: 25px; padding: 2px 5px;"><input title="Заменить спецсимволы во всех значениях" type="checkbox" onclick="checkAll(this, '')"></td>
                        <td style="width: 375px; padding: 2px 5px;">Название свойства</td>
                        <td style="width: 400px; padding: 2px 5px;">Варианты значений</td>
                    </tr>

                <?php

                $features_count = array();
                foreach ($results as $res) {
                    if (!isset($features_count[$res->feature_id])) {
                        $features_count[$res->feature_id] = 0;
                    }
                    $features_count[$res->feature_id]++;
                }
                unset($res);
                reset($results);
                foreach ($results as $res) {
                    $okay->db->query("SELECT distinct( BINARY `value`) as `value`
                      FROM `__options` 
                      WHERE `translit`=? AND `feature_id`=? AND `lang_id`=?", $res->translit, $res->feature_id, $res->lang_id);
                    $values = $okay->db->results('value');
                    ?>

                    <?php
                    if (isset($features_count[$res->feature_id]) && $features_count[$res->feature_id] >= 2) {
                        ?>
                        <tr>
                            <td style="width: 25px; padding: 2px 5px;">
                                <input style="margin-left: -15px;" onclick="checkAll(this, 'fn_feature_<?=$res->feature_id?>')" id="generate_translit_all_feature_<?=$res->feature_id?>" class="no_check" type="checkbox">
                            </td>
                            <td colspan="2"><label for="generate_translit_all_feature_<?=$res->feature_id?>" style="margin-left: -15px;">Заменить спецсимволы во всех значениях "<?=$res->name?>"</label></td>
                        </tr>
                        <?php
                        unset($features_count[$res->feature_id]);
                    }
                    ?>
                    
                    <tr>
                        <td style="width: 25px; padding: 2px 5px;vertical-align: top;">
                            <input id="value_<?=$res->lang_id?>_<?=$res->feature_id?>_<?=$res->translit?>" class="fn_feature_<?=$res->feature_id?>" title="Заменить спецсимволы" name="generate_translit[<?=$res->lang_id?>][<?=$res->feature_id?>][<?=$res->translit?>]" value="1" type="checkbox">
                        </td>

                        <td style="width: 375px; padding: 2px 5px;vertical-align: top;">
                            <label for="value_<?=$res->lang_id?>_<?=$res->feature_id?>_<?=$res->translit?>">
                                <?php
                                if (isset($langs[$res->lang_id])) {
                                    print "(".$langs[$res->lang_id].")";
                                }
                                ?>
                                <?=$res->name?>
                            </label>
                        </td>

                        <td style="width: 400px; padding: 2px 5px;vertical-align: top;">
                        <select name="new_values[<?=$res->lang_id?>][<?=$res->feature_id?>][<?=$res->translit?>]" style="max-width: 300px">
                            <?php
                                foreach ($values as $val) {
                            ?>
                                <option value="<?= $val ?>"><?= $val ?></option>
                            <?php
                                }
                            ?>
                        </select>
                            <?php
                            if (strlen($res->translit) <= 15) {
                                foreach ($values as $k=>$val) {
                                    print $val;
                                    if ($k==1) break;
                                    print "&nbsp;|&nbsp;";
                                }
                            } elseif (strlen($res->translit) <= 50) {
                                print "<br>";
                                foreach ($values as $k=>$val) {
                                    print $val."<br>";
                                    if ($k==1) break;
                                }
                            }
                            ?>
                        </td>
                    </tr>
                    <?php
                }
                ?>

                </table>

                <div>
                    <input type="submit" value="Обновить значения">
                </div>

                <?php

            } else {
                ?>
                <div class="success_text">
                    У вас все значения свойств исправлены (уникальны)
                </div>
                <?php
            }
        }
    ?>
</form>

<?php

function translit_alpha($text) {
    $translit_pairs = array(
        // русский
        array(
            'from'  => "А-а-Б-б-В-в-Ґ-ґ-Г-г-Д-д-Е-е-Ё-ё-Є-є-Ж-ж-З-з-И-и-І-і-Ї-ї-Й-й-К-к-Л-л-М-м-Н-н-О-о-П-п-Р-р-С-с-Т-т-У-у-Ф-ф-Х-х-Ц-ц-Ч-ч-Ш-ш-Щ-щ-Ъ-ъ-Ы-ы-Ь-ь-Э-э-Ю-ю-Я-я",
            'to'    => "A-a-B-b-V-v-G-g-G-g-D-d-E-e-E-e-E-e-ZH-zh-Z-z-I-i-I-i-I-i-J-j-K-k-L-l-M-m-N-n-O-o-P-p-R-r-S-s-T-t-U-u-F-f-H-h-TS-ts-CH-ch-SH-sh-SCH-sch---Y-y---E-e-YU-yu-YA-ya"
        ),
        // грузинский
        array(
            'from'  => "ა-ბ-გ-დ-ე-ვ-ზ-თ-ი-კ-ლ-მ-ნ-ო-პ-ჟ-რ-ს-ტ-უ-ფ-ქ-ღ-ყ-შ-ჩ-ც-ძ-წ-ჭ-ხ-ჯ-ჰ",
            'to'    => "a-b-g-d-e-v-z-th-i-k-l-m-n-o-p-zh-r-s-t-u-ph-q-gh-qh-sh-ch-ts-dz-ts-tch-kh-j-h"
        ),

    );
    $res = $text;
    foreach ($translit_pairs as $pair) {
        $pair['from'] = explode('-', $pair['from']);
        $pair['to'] = explode('-', $pair['to']);

        $pair = spec_pairs($pair);
        $res = str_replace($pair['from'], $pair['to'], $res);
    }

    $res = preg_replace("/[\s]+/ui", '', $res);
    $res = preg_replace("/[^a-zA-Z0-9]+/ui", '', $res);
    $res = strtolower($res);
    return $res;
}

function spec_pairs($pair) {
    $spec_pairs = array(
        '+'  => 'p',
        '-'  => 'm',
        '—'  => 'ha',
        '–'  => 'hb',
        '−'  => 'hc',
        '‐'  => 'hd',
        '/'  => 'f',
        '°'  => 'deg',
        '±'  => 'pm',
        '_'  => 'u',
        '.'  => 'd',
        ','  => 'c',
        '@'  => 'at',
        '('  => 'lb',
        ')'  => 'rb',
        '{'  => 'lf',
        '}'  => 'rf',
        '['  => 'ls',
        ']'  => 'rs',
        ';'  => 'sem',
        ':'  => 'col',
        '%'  => 'pe',
        '$'  => 'do',
        ' '  => 'sp',
        '?'  => 'w',
        '&'  => 'a',
        '*'  => 's',
        '®'  => 'r',
        '©'  => 'co',
        '\'' => 'ap',
        '"'  => 'qu',
        '`'  => 'bt',
        '<'  => 'le',
        '>'  => 'mo',
        '#'  => 'sh',
        '№'  => 'n',
        '!'  => 'em',
        '~'  => 't',
        '^'  => 'h',
        '='  => 'eq',
        '|'  => 'vs',

    );
    foreach ($spec_pairs as $symbol => $alias) {
        $pair['from'][] = $symbol;
        $pair['to'][]   = $alias;
    }

    return $pair;
}

?>
